package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
		import flash.events.MouseEvent;
		import flash.events.TextEvent;
		import flash.text.TextField;
		import flash.utils.Timer;
		import flash.events.TimerEvent;
		import flash.net.*;
	import flash.system.Security;
	//Added for Kongregate functionality
	import flash.display.LoaderInfo;
	import flash.display.Loader;
	/**
	 * ...
	 * @author Arrall Austin
	 */
	public class Main extends Sprite 
	{
		public var kongregate:*;
		
		
		public var greenonce:Boolean = false;
		public var playerscore:Number = 0;
		public var dots:Array = new Array();
		public var scoretf:TextField = new TextField();
		
		
		[Embed(source='../assets/red.png')]
		private var redClass:Class;
		private var redb:Bitmap = new  redClass();	
		
		[Embed(source='../assets/green.png')]
		private  var greenClass:Class;
		private   var greenb:Bitmap = new  greenClass();	
		
		
		[Embed(source='../assets/overlay.png')]
		private  var overlayClass:Class;
		private   var overlayb:Bitmap = new  overlayClass();	
		
		public var dott:dot = new dot();
		
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
				// Pull the API path from the FlashVars
	 var paramObj:Object = LoaderInfo(root.loaderInfo).parameters;
 
	// The API path. The "shadow" API will load if testing locally. 
	var apiPath:String = paramObj.kongregate_api_path || "http://www.kongregate.com/flash/API_AS3_Local.swf";
 
	// Allow the API access to this SWF
	Security.allowDomain(apiPath);
 
	// Load the API
	 var request:URLRequest = new URLRequest(apiPath);
	var loader:Loader = new Loader();
	loader.contentLoaderInfo.addEventListener(Event.COMPLETE, loadComplete);
	loader.load(request);
	this.addChild(loader);
	
			
			
		}
							
		
		// This function is called when loading is complete
function loadComplete(event:Event):void
{ 
	
    // Save Kongregate API reference
    kongregate = event.target.content;
 
    // Connect to the back-end
    kongregate.services.connect();
 
    // You can now access the API via:
    // kongregate.services
    // kongregate.user
    // kongregate.scores
    // kongregate.stats
    // etc...
	
	init2();
}

	

public function init2():void {
	
			scoretf.x = 10;
			scoretf.y = 0;
			root.stage.addChild(scoretf);
			
			dott.sprite.addChild(new Bitmap(redb.bitmapData));
			dott.green = false;
			
			dott.cn = new Sprite();
			dott.cn.x = root.stage.stageWidth / 2;
			dott.cn.y = root.stage.stageHeight / 2;
			dott.cn.addChild(dott.sprite);
			dott.sprite.x = 0 - dott.sprite.width / 2;
			dott.sprite.y = 0 - dott.sprite.height / 2;
				root.stage.addChild(dott.cn);
			dott.overlay.addChild(new Bitmap(overlayb.bitmapData));
			dott.overlay.x = dott.cn.x - dott.sprite.width / 2;
			dott.overlay.y = dott.cn.y - dott.sprite.height/2;
			root.stage.addChild(dott.overlay);
			dott.overlay.addEventListener(MouseEvent.ROLL_OUT, dottstop);
			dott.overlay.addEventListener(MouseEvent.ROLL_OVER, dottgo);
		
			var tt:Timer = new Timer(33, 0);
			tt.addEventListener(TimerEvent.TIMER, gameloop);
			tt.start();
			
			
			
			
	}

	
	public function dottstop(e:Event = null):void {
		
		dott.sprite.removeChildAt(0);
		dott.sprite.addChild(new Bitmap(redb.bitmapData));
		dott.green = false;
		
		}
		
		
		public function dottgo(e:Event = null):void {
			trace("hi");
			greenonce = true;
			dott.sprite.removeChildAt(0);
			dott.sprite.addChild(new Bitmap(greenb.bitmapData));
			dott.green = true;
			
			}
		
	
			private function gameloop(e:Event):void {
		scoretf.text = playerscore.toString();
				
			kongregate.stats.submit("score",playerscore); // The user killed an enemy ship
				
			
				if (dott.green == true ) {
					greenonce = true;
					var dd:Number = new Date().getTime();
				if ( dd - dott.lastdirchange > dott.dirchangedelay) {
					dott.lastdirchange = dd;
					dott.cn.rotation = dott.cn.rotation + Math.random() * 50 - 25;
					
				}
					
					var pass:Boolean = true;
					if (dott.cn.y < 30 + dott.sprite.height / 2) {
						
						dott.cn.rotation = dott.cn.rotation + 180;
						pass = false;
						}
					
					if (pass == true && dott.cn.y >  root.stage.stageHeight - 30 -  dott.sprite.height / 2) {
						
						dott.cn.rotation = dott.cn.rotation + 180;
						pass = false;
						}
						
					
						
						if (pass == true &&dott.cn.x < 30 +  dott.sprite.width / 2 ) {
						
						dott.cn.rotation = dott.cn.rotation + 180;
						pass = false;
						}
					if (pass == true && dott.cn.x > root.stage.stageWidth - 30 - dott.sprite.width / 2) {
						
						dott.cn.rotation = dott.cn.rotation + 180;
					pass = false;	
						}
					
						
						
					
					if (dott.cn.rotation > 360) { dott.cn.rotation -= 360; }
					if (dott.cn.rotation < 0) { dott.cn.rotation += 360;}
					
					
					
					
					
					
					
					
					
					
					
					
					dott.cn.x = dott.cn.x + dott.velo * Math.sin(dott.cn.rotation * Math.PI / 180);
					dott.cn.y = dott.cn.y - dott.velo * Math.cos(dott.cn.rotation * Math.PI / 180);
					dott.overlay.x = dott.cn.x - dott.sprite.width / 2;
					dott.overlay.y = dott.cn.y - dott.sprite.height / 2;
					trace(dott.velo);
					
					dott.velo = dott.velo + .02;
					playerscore += 1;
					}
					else {
						if(greenonce == true){
						dott.velo -= .02;
						playerscore -= 2;
						if (playerscore < 1) { playerscore = 0;
						dott.velo = 1;
						}
						
					}
					}
			
		
				
			}
				
			
	
			
			
				public function distance(x1:Number, y1:Number, x2:Number, y2:Number):Number {
					
					
					
					
					
					return ( Math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2)));
					
					}
			
			
					
						}
					
					
			
	}

