package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
		import flash.events.MouseEvent;
		import flash.events.TextEvent;
		import flash.text.TextField;
		import flash.text.TextFormat;
		import flash.utils.Timer;
		import flash.events.TimerEvent;
		import flash.net.*;
	import flash.system.Security;
	//Added for Kongregate functionality
	import flash.display.LoaderInfo;
	import flash.display.Loader;
	
	
	/**
	 * ...
	 * @author Arrall Austin
	 */
	public class Main extends Sprite 
	{
	
		[Embed(source = "C:\\WINDOWS\\Fonts\\times.ttf", fontFamily="ooga", embedAsCFF = "false")] 
     public var myfont:String;

	 
	 
	 public var level :Number = 1;
	 public var timer1:Number = 0;
	 public var timer2:Number = 0;
	 public var timer3:Number = 0;
	 public var started:Boolean = false;
	 
	 
	 
	 public var targets:Array = new Array();
	 public var cdot:dot;
	 public var dragging:Boolean = false;
	 public var xoff:Number = 0;
	 public var yoff:Number = 0;
		public var kongregate:*;
		public var nextvalue = 1;
		
		public var playerscore:Number = 0;
		public var dots:Array = new Array();
		public var scoretf:TextField = new TextField();
		
		
		[Embed(source='../assets/smile.png')]
		private var smileClass:Class;
		private var smileb:Bitmap = new  smileClass();	
		
		
		[Embed(source='../assets/red.png')]
		private var redClass:Class;
		private var redb:Bitmap = new  redClass();	
		
		
		[Embed(source='../assets/outline.png')]
		private var outlineClass:Class;
		private var outlineb:Bitmap = new  outlineClass();	
	
		
		
		[Embed(source='../assets/green.png')]
		private  var greenClass:Class;
		private   var greenb:Bitmap = new  greenClass();	
		
		
		[Embed(source='../assets/overlay.png')]
		private  var overlayClass:Class;
		private   var overlayb:Bitmap = new  overlayClass();	
		
		
		
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
				// Pull the API path from the FlashVars
	 var paramObj:Object = LoaderInfo(root.loaderInfo).parameters;
 
	// The API path. The "shadow" API will load if testing locally. 
	var apiPath:String = paramObj.kongregate_api_path || "http://www.kongregate.com/flash/API_AS3_Local.swf";
 
	// Allow the API access to this SWF
	Security.allowDomain(apiPath);
 
	// Load the API
	 var request:URLRequest = new URLRequest(apiPath);
	var loader:Loader = new Loader();
	loader.contentLoaderInfo.addEventListener(Event.COMPLETE, loadComplete);
	loader.load(request);
	this.addChild(loader);
	
			
			
		}
							
		
		// This function is called when loading is complete
function loadComplete(event:Event):void
{ 
	
    // Save Kongregate API reference
    kongregate = event.target.content;
 
    // Connect to the back-end
    kongregate.services.connect();
 
    // You can now access the API via:
    // kongregate.services
    // kongregate.user
    // kongregate.scores
    // kongregate.stats
    // etc...
	
	init2();
}

	

public function init2():void {
	
			scoretf.x = 10;
			scoretf.y = 0;
			root.stage.addChild(scoretf);
			level = 1;
			setuptargets(level);
			
			makedot();
			
			var tt:Timer = new Timer(33, 0);
			tt.addEventListener(TimerEvent.TIMER, gameloop);
			tt.start();
			root.stage.addEventListener(MouseEvent.MOUSE_MOVE, mmove);
			root.stage.addEventListener(MouseEvent.MOUSE_UP, mup);			
			}
	public function mmove(e:MouseEvent = null):void {
	if (dragging) {
		
		cdot.sprite.x = e.stageX - xoff;
		cdot.sprite.y = e.stageY - yoff;
		cdot.tf.x = cdot.sprite.x;
		cdot.tf.y = cdot.sprite.y;
		cdot.overlay.x = cdot.sprite.x;
		cdot.overlay.y = cdot.sprite.y;
		
		}	
		
	
		
		}
	
		
		
		public function setuptargets(level:Number):void {
				 var fmt3:TextFormat	      = new TextFormat();
         fmt3.font		      = "ooga";
          fmt3.color                = 0x000000;
          fmt3.size                 = 80;
		  fmt3.align = "center";
				
		  for each (var ff:dot in targets) {
			  
			  ff.sprite.visible = false;
			  ff.tf.visible = false;
			  ff.overlay.visible = false;
	
			  }
				  targets.splice(0, targets.length);  
		  
		  if(level == 1){
		  
		  for (var i:Number = 1; i < 6; i++) {
				
				
				
						
		
				
				var dott:dot = new dot();
				dott.value = i;
		
				
				dott.sprite.addChild(new Bitmap(outlineb.bitmapData));
				dott.sprite.x = root.stage.stageWidth - dott.sprite.width - 30;
				dott.sprite.y = 10 + (dott.value - 1) * (dott.sprite.height + 10);  
				
				root.stage.addChild(dott.sprite);
				
				dott.tf.embedFonts = true;
				dott.tf.defaultTextFormat = fmt3;
				dott.tf.text = dott.value.toString();
				dott.tf.x = dott.sprite.x;
				dott.tf.y = dott.sprite.y;
				dott.tf.width = dott.sprite.width;
				dott.tf.height = dott.sprite.height;
				dott.tf.selectable = false;
				root.stage.addChild(dott.tf);
				dott.overlay.addChild(new Bitmap(overlayb.bitmapData));
				dott.overlay.x = dott.sprite.x;
				dott.overlay.y = dott.sprite.y;
				dott.green = false;
				root.stage.addChild(dott.overlay);
			
				targets.push(dott);
				
				
				
				}
			
		  }
		  
		  
		  if (level == 2) {
			  
			  
			  	  for (var i:Number = 1; i < 11; i++) {
				
				
				
						
		
				
				var dott:dot = new dot();
				dott.value = i;
		
				
				dott.sprite.addChild(new Bitmap(outlineb.bitmapData));
				
				
				if (i < 6) {
				dott.sprite.x = 30;// root.stage.stageWidth - dott.sprite.width - 30;
					
				}else{
				dott.sprite.x = root.stage.stageWidth - dott.sprite.width - 30;
				}
				
				dott.sprite.y = 10 + ((dott.value - 1) %5) * (dott.sprite.height + 10);  
				
				root.stage.addChild(dott.sprite);
				
				dott.tf.embedFonts = true;
				dott.tf.defaultTextFormat = fmt3;
				dott.tf.text = dott.value.toString();
				dott.tf.x = dott.sprite.x;
				dott.tf.y = dott.sprite.y;
				dott.tf.width = dott.sprite.width;
				dott.tf.height = dott.sprite.height;
				dott.tf.selectable = false;
				root.stage.addChild(dott.tf);
				dott.overlay.addChild(new Bitmap(overlayb.bitmapData));
				dott.overlay.x = dott.sprite.x;
				dott.overlay.y = dott.sprite.y;
				dott.green = false;
				root.stage.addChild(dott.overlay);
			
				targets.push(dott);
				
				
				
				}
			  
			  
			  
			  
			  
			  }
			
				  if (level == 3) {
			  
				var ang:Number = 0;
				var anginc:Number = 360 / 12;
				ang = ang + anginc;
				
			  	  for (var i:Number = 1; i < 13; i++) {
				
				
				
						
		
				
				var dott:dot = new dot();
				dott.value = i;
		
				
				dott.sprite.addChild(new Bitmap(outlineb.bitmapData));
				
				/*
				if (i < 6) {
				dott.sprite.x = 30;// root.stage.stageWidth - dott.sprite.width - 30;
					
				}else{
				dott.sprite.x = root.stage.stageWidth - dott.sprite.width - 30;
				}
				
				
				
				
				
				
				dott.sprite.y = 10 + ((dott.value - 1) %5) * (dott.sprite.height + 10);  
			
			  	*/
				
				
				
				dott.sprite.x = root.stage.stageWidth / 2 - dott.sprite.width/2 + 220 * Math.sin(ang * Math.PI / 180);
				dott.sprite.y = root.stage.stageHeight / 2 - dott.sprite.height/2 - 220 * Math.cos(ang * Math.PI / 180);
				
				
				
				root.stage.addChild(dott.sprite);
				
				dott.tf.embedFonts = true;
				dott.tf.defaultTextFormat = fmt3;
				dott.tf.text = dott.value.toString();
				dott.tf.x = dott.sprite.x;
				dott.tf.y = dott.sprite.y;
				dott.tf.width = dott.sprite.width;
				dott.tf.height = dott.sprite.height;
				dott.tf.selectable = false;
				root.stage.addChild(dott.tf);
				dott.overlay.addChild(new Bitmap(overlayb.bitmapData));
				dott.overlay.x = dott.sprite.x;
				dott.overlay.y = dott.sprite.y;
				dott.green = false;
				root.stage.addChild(dott.overlay);
			
				targets.push(dott);
				
				ang = ang + anginc;
				
				
				
				
				}
			  
			  
			  
			  
			  
			  }
			
			
			
			}
		
		
	
			private function gameloop(e:Event):void {
		
				
			
			//kongregate.stats.submit("Score",playerscore); // The user killed an enemy ship
				
		if (started == true && level == 1) { timer1++; }
		if (started == true && level == 2) { timer2++; }
		if (started == true && level == 3) { timer3++;}
			
						
			}
				
			
			public function makedot():void {
				
				 var fmt3:TextFormat	      = new TextFormat();
         fmt3.font		      = "ooga";
          fmt3.color                = 0x000000;
          fmt3.size                 = 80;
		  fmt3.align = "center";
				
				
				var dott:dot = new dot();
				dott.value = nextvalue;
				nextvalue++;
				
				dott.sprite.addChild(new Bitmap(redb.bitmapData));
				
				if(level == 1){
				dott.sprite.x = 20;
				}
				if (level == 2) {
					
					dott.sprite.x = root.stage.stageWidth / 2 - dott.sprite.width/2;
					}
				
				dott.sprite.y = Math.random() * root.stage.stageHeight / 2; + root.stage.stageHeight / 2;
				
				if (level == 3) {
					
					dott.sprite.x = root.stage.stageWidth / 2 - dott.sprite.width / 2;
					dott.sprite.y = root.stage.stageHeight / 2 - dott.sprite.height / 2;
					
					}
				
				
				root.stage.addChild(dott.sprite);
				
				dott.tf.embedFonts = true;
				dott.tf.defaultTextFormat = fmt3;
				dott.tf.text = dott.value.toString();
				dott.tf.x = dott.sprite.x;
				dott.tf.y = dott.sprite.y;
				dott.tf.width = dott.sprite.width;
				dott.tf.height = dott.sprite.height;
				dott.tf.selectable = false;
				root.stage.addChild(dott.tf);
				dott.overlay.addChild(new Bitmap(overlayb.bitmapData));
				dott.overlay.x = dott.sprite.x;
				dott.overlay.y = dott.sprite.y;
				dott.overlay.addEventListener(MouseEvent.MOUSE_DOWN, startmove);
				dott.overlay.addEventListener(MouseEvent.MOUSE_UP, mup2);
				dott.green = false;
				cdot = dott;
				root.stage.addChild(dott.overlay);
			
				}
			
				
				public function mup(e:Event = null):void {
					if (dragging == true) { dragging = false;
					if (cdot.green == true) { cdot.green = false;
					cdot.sprite.removeChildAt(0);
					cdot.sprite.addChild(new Bitmap(redb.bitmapData));
					}

					
					for each(var ff:dot in targets) {
						if (cdot.value == ff.value && distance( (cdot.sprite.x + cdot.sprite.width / 2), (cdot.sprite.y + cdot.sprite.height / 2), (ff.sprite.x + ff.sprite.width / 2), (ff.sprite.y + ff.sprite.height / 2)) < ((ff.sprite.width / 2) +5)) {
							
							ff.tf.visible = false;
							ff.overlay.visible = false;
							ff.sprite.removeChildAt(0);
							ff.sprite.addChild(new Bitmap(smileb.bitmapData));
							
							cdot.sprite.visible = false;
							cdot.tf.visible = false;
							cdot.overlay.visible = false;
							
							if (ff.value == 5 && level == 1) {
								level++;
								kongregate.stats.submit("level1time",timer1); // The user killed an enemy ship
								timer1 = 0;

								setuptargets(level);
								nextvalue = 1;
								}
										
							if (ff.value == 10 && level == 2) {
								level++;
								kongregate.stats.submit("level2time",timer2); // The user killed an enemy ship
								timer2 = 0;
								
								
								setuptargets(level);
								nextvalue = 1;
								}
								
								
							if (ff.value == 12 && level == 3) {
								level = 1;
								kongregate.stats.submit("level3time",timer3); // The user killed an enemy ship
								timer3 = 0;
								
								
								setuptargets(level);
								nextvalue = 1;
								}
								
							
							makedot();
							
							}
						
						
						
						
						}
					
					
					
				}}

					
				public function mup2(e:Event = null):void {
					if (dragging == true) { dragging = false;
					if (cdot.green == true) { cdot.green = false;
					cdot.sprite.removeChildAt(0);
					cdot.sprite.addChild(new Bitmap(redb.bitmapData));
					
							for each(var ff:dot in targets) {
						if (cdot.value == ff.value && distance( (cdot.sprite.x + cdot.sprite.width / 2), (cdot.sprite.y + cdot.sprite.height / 2), (ff.sprite.x + ff.sprite.width / 2), (ff.sprite.y + ff.sprite.height / 2)) < ((ff.sprite.width / 2) +5)) {
							
							ff.tf.visible = false;
							ff.overlay.visible = false;
							ff.sprite.removeChildAt(0);
							ff.sprite.addChild(new Bitmap(smileb.bitmapData));
								cdot.sprite.visible = false;
							cdot.tf.visible = false;
							cdot.overlay.visible = false;
								
							
							if (ff.value == 5 && level == 1) {
								level++;
								
									kongregate.stats.submit("level1time",timer1); // The user killed an enemy ship
								timer1 = 0;

								
								setuptargets(level);
								nextvalue = 1;
								}
							
								
							if (ff.value == 10 && level == 2) {
								level++;
								kongregate.stats.submit("level2time",timer2); // The user killed an enemy ship
								timer2 = 0;
								
								setuptargets(level);
								nextvalue = 1;
								}
								
								
								
																
							if (ff.value == 12 && level == 3) {
								level = 1;
								kongregate.stats.submit("level3time",timer3); // The user killed an enemy ship
								timer3 = 0;
								
								
								setuptargets(level);
								nextvalue = 1;
								}

								
							makedot();
							
							
							}
						
						
						
						
						}
					
					}
					
					
					
					
					
					}
				}
					
					
				public function startmove(e:MouseEvent = null):void {
				if (cdot.green == false) { cdot.green = true;
				cdot.sprite.removeChildAt(0);
				cdot.sprite.addChild(new Bitmap(greenb.bitmapData));
				dragging = true;
				
				xoff = ( e.stageX - e.currentTarget.x );
				yoff =( e.stageY - e.currentTarget.y );
				if (started == false) { started = true;}
				
				}
				}
			
				public function distance(x1:Number, y1:Number, x2:Number, y2:Number):Number {
					
					
					
					
					
					return ( Math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2)));
					
					}
			
			
					
					public function overlayclick(e:Event = null):void {
						
													var found:dot = null;
						
						for each(var fj:dot in dots) {
							
							if (fj.overlay.x == e.currentTarget.x && fj.overlay.y == e.currentTarget.y) {
								found = fj;
								
							}
					
							}
						
						
						
						
						}
					
					
	
	}
}
	
