package 
{
	// Imports add existing code and functions to your program
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.display.Bitmap;
	/**
	 * ...
	 * @author Arrall Austin
	 * This is a simple counting game for young children.
	 *
	 *
	 */
	
	 
	 
	 // this is the Main Class where our program mostly comes from.
	[Frame(factoryClass="Preloader")]
	public class Main extends Sprite 
	{
		
		
		//These are variables of different types declared so that all of
		//the functions of this class can access them.
		public static var butarray:Array = new Array();
		public static var objarray:Array = new Array();
		public static var numobj:Number;
		public static var currentcount:Number;
		public static var playa1:Sound;
		public static var playa2:Sound;
		public static var playa3:Sound;
		public static var playa4:Sound;
		public static var playa5:Sound;
		public static var playa6:Sound;
		public static var playa7:Sound;
		public static var playa8:Sound;
		public static var playa9:Sound;
		public static var myoops:Sound;
		public static var mycorrect:Sound;
		public static var myintro:Sound;
		
		
		
		[Embed(source = "C:\\WINDOWS\\Fonts\\comic.ttf", fontFamily="ooga", embedAsCFF = "false")] 
      public var ffsbar:String;
	
	  
	  
	  
	  // Thesee are images files embedded into the program
	  
	  
	  [Embed(source='../assets/apple.png')]
		private static var appleClass:Class;
		private static var appleb:Bitmap = new appleClass();
		
		 [Embed(source='../assets/banana.png')]
		private static var bananaClass:Class;
		private static var bananab:Bitmap = new bananaClass();
		
		  [Embed(source='../assets/iconbackground.png')]
		private static var iconbgClass:Class;
		private static var iconbgb:Bitmap = new iconbgClass();
			
				  [Embed(source='../assets/1.png')]
		private static var n1Class:Class;
		private static var n1:Bitmap = new n1Class();
		
				  [Embed(source='../assets/2.png')]
		private static var n2Class:Class;
		private static var n2:Bitmap = new n2Class();
		
				  [Embed(source='../assets/3.png')]
		private static var n3Class:Class;
		private static var n3:Bitmap = new n3Class();
		
				  [Embed(source='../assets/4.png')]
		private static var n4Class:Class;
		private static var n4:Bitmap = new n4Class();
		
				  [Embed(source='../assets/5.png')]
		private static var n5Class:Class;
		private static var n5:Bitmap = new n5Class();
		
				  [Embed(source='../assets/6.png')]
		private static var n6Class:Class;
		private static var n6:Bitmap = new n6Class();
		
				  [Embed(source='../assets/7.png')]
		private static var n7Class:Class;
		private static var n7:Bitmap = new n7Class();
		
				  [Embed(source='../assets/8.png')]
		private static var n8Class:Class;
		private static var n8:Bitmap = new n8Class();
		
				  [Embed(source='../assets/9.png')]
		private static var n9Class:Class;
		private static var n9:Bitmap = new n9Class();
		
		
		
		
		
		
		
		
		// These are sound files embedded into the program
		
			 [Embed(source = '../assets/sound/a1.mp3')]
		 public var a1:Class;
		
		 [Embed(source = '../assets/sound/a2.mp3')]
		 public var a2:Class;
		  [Embed(source = '../assets/sound/a3.mp3')]
		 public var a3:Class;
		  [Embed(source = '../assets/sound/a4.mp3')]
		 public var a4:Class;
		  [Embed(source = '../assets/sound/a5.mp3')]
		 public var a5:Class;
		  [Embed(source = '../assets/sound/a6.mp3')]
		 public var a6:Class;
		  [Embed(source = '../assets/sound/a7.mp3')]
		 public var a7:Class;
		  [Embed(source = '../assets/sound/a8.mp3')]
		 public var a8:Class;
		  [Embed(source = '../assets/sound/a9.mp3')]
		 public var a9:Class;
		 
		  [Embed(source = '../assets/sound/oops.mp3')]
		 public var oops:Class;
		 
		  [Embed(source = '../assets/sound/correct.mp3')]
		 public var corr:Class;
		 
		 
		   [Embed(source = '../assets/sound/intro.mp3')]
		 public var intro:Class;
		 
		 
		
		
		public function Main():void 
		{
			//This code checks to see if the stage is ready
			//Once ready it calls Init().
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}

		private function init(e:Event = null):void 
		{
			
			//Once the stage is ready, this init function is called
			//and the eventlistener is removed
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
		
			
			//This for loop creates the buttons on the bottom of the app
			//It increases the value of i by one each iteration(go around).
			//It offsets the next button by a fixed amount
			for (var i:Number = 1; i < 10; i++) {
				
				//obook is a custom class that just holds data about sprites
				//and buttons. It is defined in a file called obook.as which
				//is required to be in the src folder for this part to work.
				var ob:obook = new obook;
				
				//This adds a copy of the green button background to the 
				//background sprite in the ob object.
				ob.background.addChild(new Bitmap(iconbgb.bitmapData));
				
				//This line of code offsets the start of the row of buttons
				//by 80, and then places a new button every 60 pixels across
				//the bottom of the screen.
				ob.background.x = i*60 + 80;
				
				//This line of code sets each button's y position(height)
				//To 400, so they all line up just above the bottom of the app.
				ob.background.y = 400;
				
				//This code gets a number picture based on the i (the current
				//counter value, so 1 appears on the first button and so on.
				var bb:Bitmap = getoverlay(i);
				
				//this line adds the copied bitmap to the background sprite (on
				//top of the button background image.
				ob.background.addChild(bb);
				
				//This line of code adds an event listener (it checks for clicks
				//on the background sprite (our button) and calls the "buttonclick"
				//function to handle button clicks on each button
				ob.background.addEventListener(MouseEvent.CLICK, buttonclick);
				
				//This code offsets the number by a small amount so it appears
				//closer to the center of the background/button sprite. It moves
				//its position within its container sprite(background)
				bb.x += 5;
				bb.y += 5;
				
				//This code adds the sprite we have been adding to to the screen.
				root.stage.addChild(ob.background);
				
				//This line of code stores the value of the button that has
				//been created.
				ob.myval = i;
				
				//This line of code adds the ob class object to an array
				//which keeps track of buttons. The array was declared 
				//at the top of the Main class. It is global to the app.
				butarray.push(ob);
				
				} //End for loop
		
			//This code creates new sounds based on the embedded sound files	
			playa1 = (new a1) as Sound;
			playa2 = (new a2) as Sound;
			playa3 = (new a3) as Sound;
			playa4= (new a4) as Sound;
			playa5 = (new a5) as Sound;
			playa6 = (new a6) as Sound;
			playa7 = (new a7) as Sound;
			playa8 = (new a8) as Sound;
			playa9 = (new a9) as Sound;
			myoops = (new oops) as Sound;	
			mycorrect = (new corr) as Sound;	
			myintro = (new intro) as Sound;
			
			
			//This code plays the introduction blurb once.
			myintro.play();
			
			//This code calls the makequestion function which generates
			//a question to be answered and provides counting objects
			//to click on as well as enabling correct button presses
			//to result in further questions.
			makequestion();
			
			}
		
				//This function plays a sound based on the the number
				//passed to the function. 1 plays the 1 audio file.
				public function playsound(i):void {
					if (i == 1) { playa1.play(); }
					if (i == 2) { playa2.play(); }
					if (i == 3) { playa3.play(); }
					if (i == 4) { playa4.play(); }
					if (i == 5) { playa5.play(); }
					if (i == 6) { playa6.play(); }
					if (i == 7) { playa7.play(); }
					if (i == 8) { playa8.play(); }
					if (i == 9) { playa9.play(); }
						}
				
				
				
				//This function returns a copy of a bitmap(by accessing the
				//bitmapData property of the existing images. It is used 
				//for both button and object overlays.
		public function getoverlay(i:Number):Bitmap {
			
			if (i == 1) { return(new Bitmap(n1.bitmapData)); }
			if (i == 2) { return(new Bitmap(n2.bitmapData)); }
			if (i == 3) { return(new Bitmap(n3.bitmapData)); }
			if (i == 4) { return(new Bitmap(n4.bitmapData)); }
			if (i == 5) { return(new Bitmap(n5.bitmapData)); }
			if (i == 6) { return(new Bitmap(n6.bitmapData)); }
			if (i == 7) { return(new Bitmap(n7.bitmapData)); }
			if (i == 8) { return(new Bitmap(n8.bitmapData)); }
			if (i == 9) { return(new Bitmap(n9.bitmapData)); }
			
			return(new Bitmap(n1.bitmapData));
			}
			
			
			
			//This is the function that allows new questions to appear.
			public function makequestion():void {
				
				//This line randomly picks a number between 1 and 2
				//which determines if apples or bananas appear
				var otype:Number  = Math.ceil(Math.random() * 2);
				
				
				//This code emptys the array of objects
				var remover:obook = objarray.shift();
				while (remover) { remover.background.visible = false; remover = objarray.shift(); }
				
				//This code determines how many objects will appear for this question.
				numobj= Math.ceil(Math.random() * 9);
				//This line sets the current count to one for determining which
				//number to place on a clicked object.
				currentcount = 1;
				
				//These variables are used in the while function that sets up the counting question.
				var done:Number = 0;
				var counter:Number = 1;
				
				//This While loop continues until done == 1 or the number of objects to count has
				//been reached.
				while (!done && counter <= numobj) {
					
					//The flag variable is used to determine if an object is too close to another object.
					
					var flag:Number = 0;
					var obj:obook = new obook;
				
					//A random location is chosen to attempt to place an object.
					var x:Number = Math.random() * 600 + 40;
					var y:Number = Math.random() * 280 + 40;
					
					
					//This is a for each loop that compares the distances of all objects so far created
					//with the current random location. If the location is safe, a new object is placed on the screen.
					for each(var ob:obook in objarray) {
				
						//This code determines the distance between the random location and each existing object
						var d:Number = distance(x + ob.background.width / 2 , y + obj.background.height / 2 , ob.background.x + obj.background.width / 2,  ob.background.y + obj.background.height / 2 ); 
				
						//if the distance is too short, the flag is set to 1 and the counter variable is not increased.
						if(d < 120){
							flag = 1;
							
							}
			
						}
						//If the new random location is acceptable, a new object is placed on the screen.
				if (flag == 0) {
					
					//This line gets either an apple or banana	
					obj.background.addChild(getotype(otype));
					
						//These two lines set the position of the object to the randomly chosen spot
						obj.background.x = x;	
						obj.background.y = y;
						
						//The object sprite is added to the stage here
						root.stage.addChild(obj.background);
						
						//The sprite is given an objclick event listener which lets
						//numbers appear on the top of apples and oranges when clicked.
						obj.background.addEventListener(MouseEvent.CLICK, objclick);
						
						//The new object is put in the objarray here (a global array variable)
						objarray.push(obj);
						
						//The counter is increased here to work on the next numbered object
						counter++;
					
					}

					}
	
				}
				
				
				//This function returns a copy of a bitmap based on the number given.
				//The function is called with a random number to pick between apples and bananas
				public function getotype(i):Bitmap {
					if (i == 1) { return(new Bitmap(appleb.bitmapData)); }
					if (i == 2) { return(new Bitmap(bananab.bitmapData)); }
					
					//This line is here because the function must return a value in all cases.
					return (  new Bitmap(appleb.bitmapData));
					}
				
				
					
					
					//The objclick function scans the objarray for the object that was clicked on
					//and then updates the object sprite with a number overlay
				public function objclick(e:Event):void {
					
					
					//This segment of code scans the array of objarray for an object that matches
					//the x and y coordinates of the object that was clicked on. Once they match
					//the ob variable points to the existing object in the array.
					var ob:obook;
					for each(var fb:obook in objarray) {
						
						if (fb.background.x == e.currentTarget.x && fb.background.y == e.currentTarget.y) {
							ob = fb;
							}
						}
					
						//This if statement checks for a valid, unpressed object and adds a number overlay.
					if(currentcount<=numobj && ob.pressed == 0){	
					
					//This line of code gets an overlay based on the currentcount global variable	
					var bb:Bitmap = getoverlay(currentcount);
					
					//This line of code toggles the variable pressed of the object which prevents it from
					//being pressed again during this question (it keeps the number from stacking up top of each other.
					ob.pressed = 1;
					bb.x += 20;
					bb.y += 25;
					ob.background.addChild(bb);
					playsound(currentcount);
					currentcount++;
					}
					
					}
				
				
				
				public function buttonclick(e:Event):void {
					
					var ob:obook;
					for each(var fb:obook in butarray) {
						
						if (fb.background.x == e.currentTarget.x && fb.background.y == e.currentTarget.y) {
							
							
							ob = fb;
							
							}
						
						
						}
					
					
					if (ob.myval == numobj) {
						mycorrect.play();
						makequestion();
						
						
						
						}else {
							
							myoops.play();
							}
					
					
					}
				
				
				
				
				
				
				
				
				public function distance(x1, y1, x2, y2):Number {
					
					
					
					return(Math.sqrt( (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2)));
					
					
					
					
					}
				
				
				
				

	}

}