package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
		import flash.events.MouseEvent;
		import flash.events.TextEvent;
		import flash.text.TextField;
		import flash.utils.Timer;
		import flash.events.TimerEvent;
		import flash.net.*;
		import flash.media.Sound;
	import flash.media.SoundChannel;
	
	import flash.system.Security;
	//Added for Kongregate functionality
	import flash.display.LoaderInfo;
	import flash.display.Loader;
	/**
	 * ...
	 * @author Arrall Austin
	 */
	public class Main extends Sprite 
	{
		
		public var playerscore:Number = 0;
		public var dots:Array = new Array();
		public var scoretf:TextField = new TextField();
		
			public static var playseoops:Sound;
		public static var playsgreen1:Sound;
	
		
		
			
		// These are sound files embedded into the program
		
			 [Embed(source = '../assets/sound/seoops.mp3')]
		 public var seoops:Class;
	
		
			 [Embed(source = '../assets/sound/sgreen1.mp3')]
		 public var sgreen1:Class;
	
		 
		 
		[Embed(source='../assets/red.png')]
		private var redClass:Class;
		private var redb:Bitmap = new  redClass();	
		
		[Embed(source='../assets/green.png')]
		private  var greenClass:Class;
		private   var greenb:Bitmap = new  greenClass();	
		
		
		[Embed(source='../assets/overlay.png')]
		private  var overlayClass:Class;
		private   var overlayb:Bitmap = new  overlayClass();	
		
		
		
		public static var kongregate:*;
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
				// Pull the API path from the FlashVars
	 var paramObj:Object = LoaderInfo(root.loaderInfo).parameters;
 
	// The API path. The "shadow" API will load if testing locally. 
	var apiPath:String = paramObj.kongregate_api_path || "http://www.kongregate.com/flash/API_AS3_Local.swf";
 
	// Allow the API access to this SWF
	Security.allowDomain(apiPath);
 
	// Load the API
	 var request:URLRequest = new URLRequest(apiPath);
	var loader:Loader = new Loader();
	loader.contentLoaderInfo.addEventListener(Event.COMPLETE, loadComplete);
	loader.load(request);
	this.addChild(loader);

	
			
			
		}
							
		
		// This function is called when loading is complete
function loadComplete(event:Event):void
{ 
	
    // Save Kongregate API reference
    kongregate = event.target.content;
 
    // Connect to the back-end
    kongregate.services.connect();
 
    // You can now access the API via:
    // kongregate.services
    // kongregate.user
    // kongregate.scores
    // kongregate.stats
    // etc...
	
	init2();
}

	

public function init2():void {
	
			scoretf.x = 10;
			scoretf.y = 0;
			root.stage.addChild(scoretf);
			
				
		
			//This code creates new sounds based on the embedded sound files	
			playseoops = (new seoops) as Sound;
			playsgreen1 = (new sgreen1) as Sound;
		
			
			
			var tt:Timer = new Timer(33, 0);
			tt.addEventListener(TimerEvent.TIMER, gameloop);
			tt.start();
			
	}

			private function gameloop(e:Event):void {
		
				
			
				handlenewdots();
				
				
				
				scoretf.text = playerscore.toString();
				
				
				
				for each(var dd:dot in dots) {
					dd.life--;
					
					if (dd.life < 1) {
					if (dd.green == true) {
						playerscore -=2;
					
					
						} else {
							
							
							playerscore++;
						}
					
					dd.sprite.visible = false;
					dd.overlay.visible = false;
					dd.tf.visible = false;
					dots.splice(dots.lastIndexOf(dd), 1);
						}
					
					
					}
				
				
		
				
			}
				
			
			public function handlenewdots(e:Event = null):void { 
				
				if (dots.length < 6) {
					
					makedot();
					
					}
				
				
				}
			
			
				public function distance(x1:Number, y1:Number, x2:Number, y2:Number):Number {
					
					
					
					
					
					return ( Math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2)));
					
					}
			
			
					
					public function overlayclick(e:Event = null):void {
						
													var found:dot = null;
						
						for each(var fj:dot in dots) {
							
							if (fj.overlay.x == e.currentTarget.x && fj.overlay.y == e.currentTarget.y) {
								found = fj;
								
							}
					
							}
						
							
							if (found.green == true) {
								playerscore++;
								kongregate.stats.submit("greens",1); // The user killed an enemy ship
								playsgreen1.play();
								found.tf.visible = false;
								found.sprite.visible = false;
								found.overlay.visible = false;
								
								dots.splice(dots.lastIndexOf(found), 1);
								
								
								}
								else { 
									playseoops.play();	
								found.tf.visible = false;
								found.sprite.visible = false;
								found.overlay.visible = false;
								
								dots.splice(dots.lastIndexOf(found), 1);
									
									playerscore -=2;
								
								
								}
						
						
						
						
						}
					
					
					
			public function makedot():void {
				
				
				
				var dd:dot = new dot();
				
				dd.maxlife = 100 - playerscore / 2;
				if (dd.maxlife < 1) { dd.maxlife = 1; }
				dd.life =  dd.maxlife;
				
				
				var pass:Boolean = false;
				while(pass == false){
				pass = true;
				var x:Number = Math.random() * (root.stage.stageWidth - greenb.width - 10) + 10;
				var y:Number = Math.random() * (root.stage.stageHeight - greenb.height - 10) + 10;
				
				for each(var d2:dot in dots) {
					
					if (distance(x, y, d2.sprite.x, d2.sprite.y) < d2.sprite.width + 5) { pass = false;}
					
					
					
					}
				
				
				
				}
				
				if (Math.random() > .5) { 
					
					dd.green = true; 
						dd.sprite.addChild(new Bitmap(greenb.bitmapData));
				dd.sprite.x = x;
				dd.sprite.y = y;
						
						root.stage.addChild(dd.sprite);

					
					dd.overlay.addChild(new Bitmap(overlayb.bitmapData));
					dd.overlay.addEventListener(MouseEvent.CLICK, overlayclick);
					dd.overlay.x = dd.sprite.x;
					dd.overlay.y = dd.sprite.y;
					
					root.stage.addChild(dd.overlay);
					
					} else { 
						
						
				
						dd.sprite.addChild(new Bitmap(redb.bitmapData));
						dd.green = false;
						dd.sprite.x = x;
						dd.sprite.y = y;
						
						root.stage.addChild(dd.sprite);
						
					dd.overlay.addChild(new Bitmap(overlayb.bitmapData));
					dd.overlay.addEventListener(MouseEvent.CLICK, overlayclick);
					dd.overlay.x = dd.sprite.x;
					dd.overlay.y = dd.sprite.y;
					
					root.stage.addChild(dd.overlay);
				
						}
				
				
				
				dots.push(dd);
			
				
				
				
				}
	}
}
	
